
#include <setplay/setplay.h>
#include <setplay/cond.h>
#include <setplay/setplaymessage.h>
#include <setplay/setplaymanager.h>
#include <setplay/region.h>
#include <setplay/namesubstitutions.h>
#include <setplay/clang/vector.h>


using namespace std;
using namespace rcss::geom;
using namespace fcportugal::setplay;

class ContextTanga: public fcportugal::setplay::Context
      {
      public:
	ContextTanga()
	{}

	virtual 
	~ContextTanga()
	{}

	virtual 
	bool
	lookup( const CondPlayerPos& cond ) const {return false;}


	virtual 
	bool
	lookup( const CondBallOwner& cond ) const {return false;}

	virtual 
	bool
	lookup( const CondClearShotAtGoal& cond ) const {return false;}

	virtual 
	bool
	lookup( const CondClearPassToPlayer& cond ) const  {return false;}

	virtual 
	bool
	lookup( const CondClearPassToRegion& cond ) const  {return false;}

	virtual 
	bool
	lookup( const CondPlayMode& cond ) const  {return false;}

	
	virtual 
	bool
	lookup( const CondBallPos& cond ) const  {return false;}

	virtual 
	bool
	lookup( const CondNamed& cond ) const  {return false;}

	virtual 
	bool
	lookup( const CondTime& cond ) const  {return false;}

	virtual 
	bool
	lookup( const CondOppGoal& cond ) const  {return false;}

	virtual 
	bool
	lookup( const CondOurGoal& cond ) const {return false;}

	virtual 
	bool
	lookup( const CondGoalDiff& cond ) const  {return false;}

	virtual 
	bool
	lookup( const CondNearOffsideLine& cond ) const{return false;}

	double time() const {return 0;}

	  virtual double fieldLength() const{return 0;}
	virtual double fieldWidth() const{return 0;}
	const fcportugal::setplay::PointSimple* const
	ballPos() const{return new const PointSimple(new Decimal(0),new Decimal(0));}
	
	const fcportugal::setplay::PointSimple* const
	playerPos(const fcportugal::setplay::PlayerID& pl) const{return new const PointSimple(new Decimal( pl.number),new Decimal(-1));}

	const rcss::clang::PlayMode playMode() const{
	  return rcss::clang::BeforeKickOff;
	}
  
	// For name substitutions
        const fcportugal::setplay::NameSubstitutions& nameSubstitutions() const{
	  return *(new const fcportugal::setplay::NameSubstitutions());
	}
	const unsigned int numPlayersPerTeam() const{return 11;}
	const std::string& opponentName() const{return *(new string("tanga"));};

      }; // end Context


int main(int argc,char *argv[])
{
  if(argc!=1) {cerr<<"No args!"<<endl;
    return -1;}

  const fcportugal::setplay::Context* tg=new ContextTanga();

  // Esta' preparado para trabalhar com o fic
  // fora_devolucao_marcador_sem params
  SetplayManager setplayManager("teste","jogadas/fora_devolucao_marcador_sem_params.txt",
				true,true,NULL,0,*tg);  

  setplayManager.setMyPlayerID(new PlayerID("our",2));


  cout<<"Original:"<<setplayManager.numberOfSetplays()<<endl;
  for(unsigned int i=0; i!=setplayManager.numberOfSetplays();i++){
    cout<<"Jogada "<<i<<":\n";
    setplayManager.writeSetplayNum(cout,i);
    cout<<"_____________________________________________"<<endl;
  }
  cout<<"\n\n___________\n\n"<<endl;


  
  //Substituicao de uma regiao nomeada
  cout<<"\n\n-------SUBST-------\n\n";
  RegPoint* reg = new RegPoint(new PointSimple(new Decimal(4),
					       new Decimal(44)));
  RegPoint* reg2 = new RegPoint(new PointSimple(new Decimal(33),
						new Decimal(333)));
  NameSubstitutions ns;
  
  RegNamed* regN=new RegNamed("their_middle_field");
  regN->setRegion(reg);
  ns.addSubstitution("their_middle_field",regN);
  regN=new RegNamed("our_middle_field");
  regN->setRegion(reg2);
  ns.addSubstitution("our_middle_field",regN);
  regN=new RegNamed("right");
  regN->setRegion(reg);
  ns.addSubstitution("right",regN);
  regN=new RegNamed("left");
  regN->setRegion(reg2);
  ns.addSubstitution("left",regN);

  setplayManager.substituteNamedRegions(*tg);

  for(unsigned int i=0; i!=setplayManager.numberOfSetplays();i++){
    cout<<"Jogada "<<i<<":\n";
    setplayManager.writeSetplayNum(cout,i);
    cout<<"_____________________________________________"<<endl;
  }
  cout<<"\n\n____SUBST2_______\n\n"<<endl;

  reg= new RegPoint(new PointSimple(new Decimal(555),new Decimal(555)));
  reg2= new RegPoint(new PointSimple(new Decimal(66),new Decimal(666)));
  NameSubstitutions ns2;
  regN=new RegNamed("their_middle_field");
  regN->setRegion(reg);
  ns2.addSubstitution("their_middle_field",regN);
  regN=new RegNamed("our_middle_field");
  regN->setRegion(reg2);
  ns2.addSubstitution("our_middle_field",regN);
  regN=new RegNamed("right");
  regN->setRegion(reg);
  ns2.addSubstitution("right",regN);
  regN=new RegNamed("""");
  regN->setRegion(reg2);
  ns2.addSubstitution("left",regN);

  setplayManager.substituteNamedRegions(*tg);
  
  for(unsigned int i=0; i!=setplayManager.numberOfSetplays();i++){
    cout<<"Jogada "<<i<<":\n";
    setplayManager.writeSetplayNum(cout,i);
    cout<<"_____________________________________________"<<endl;
  }
  cout<<"\n\n_____INSTANCIACAO______\n\n"<<endl;
  

  
  //   //instancias
  vector<const string*>* arguments=new vector<const string*>;

  //Offsets/Parameters
  // Neste caso, nao ha' parametros
  //arguments->push_back(new const string("9"));
  //arguments->push_back(new const string("10"));

  //Players
  arguments->push_back(new const string("2"));
  arguments->push_back(new const string("3"));
  
  // With full playerID's:
  //arguments->push_back(new string("(player :team our :number 2)"));
  //arguments->push_back(new string("(player :team our :number 4)"));
  
  InitMessage* initMessage
    = new InitMessage(300, 0,arguments);
  
  
  cout<<"\nEsta' activo?"<<setplayManager.isSetplayActive()<<endl;
  setplayManager.activateSetplay(*initMessage,*tg);
  setplayManager.writeCurrentSetplay(cout);
  cout<<"\nEsta' activo?"<<setplayManager.isSetplayActive()<<endl;

 
 //  InitMessage* initMessage2
  // = new InitMessage(300,"S0 -10;0 -17;3 -17;-3 2 3 2 4");

 //  StepMessage* stepMessage
//     = new StepMessage(300,"1 2");
//   cout<<  stepMessage->toString()<<endl;
//   StepMessage* stepMessage2
//     = new StepMessage(300,3, 2);
//   cout<<  stepMessage2->toString()<<endl;
  //delete initMessage;
 
//   // Teste a subst bola e jogadores
  PointSimple* ball = new PointSimple(new Decimal(0.205265),new Decimal(0.0717366));

  vector<PointSimple*>* pl=new vector<PointSimple*>;

  pl->push_back(new PointSimple(new Decimal(0),new Decimal(0)));
  pl->push_back(new PointSimple(new Decimal(0),new Decimal(0)));
  pl->push_back(new PointSimple(new Decimal(-17),new Decimal(13)));
  pl->push_back(new PointSimple(new Decimal(-16.7),new Decimal(2.6)));
  pl->push_back(new PointSimple(new Decimal(-17),new Decimal(-6.1)));
  pl->push_back(new PointSimple(new Decimal(-17),new Decimal(-17)));
  pl->push_back(new PointSimple(new Decimal(-8),new Decimal(-1)));
  pl->push_back(new PointSimple(new Decimal(-3),new Decimal(11)));
  pl->push_back(new PointSimple(new Decimal(-3),new Decimal(-15)));
  pl->push_back(new PointSimple(new Decimal(-1),new Decimal(-2)));
  pl->push_back(new PointSimple(new Decimal(-1),new Decimal(19)));

  vector<PointSimple*>* op=new vector<PointSimple*>;
  op->push_back(new PointSimple(new Decimal(0),new Decimal(0)));
  op->push_back(new PointSimple(new Decimal(0),new Decimal(0)));
  op->push_back(new PointSimple(new Decimal(0),new Decimal(13)));
  op->push_back(new PointSimple(new Decimal(0),new Decimal(3)));
  op->push_back(new PointSimple(new Decimal(0),new Decimal(-6)));
  op->push_back(new PointSimple(new Decimal(0),new Decimal(-17)));
  op->push_back(new PointSimple(new Decimal(0),new Decimal(-1)));
  op->push_back(new PointSimple(new Decimal(0),new Decimal(11)));
  op->push_back(new PointSimple(new Decimal(0),new Decimal(-16)));
  op->push_back(new PointSimple(new Decimal(0),new Decimal(-3)));
  op->push_back(new PointSimple(new Decimal(0),new Decimal(19)));

  cout<<"\nEsta' activo?"<<setplayManager.isSetplayActive()<<endl;
  //No se pode experimentar o autoActivate, tem de ter algo a ser mandado
  //como primeiro argumento, nao pode ser NULL
 //  setplayManager.autoActivate(NULL,ball,pl,op);


  cout<<"_____________________________________________"<<endl;
  cout<<"SUBSTITUICAO DE POSICOES DA BOLA E JOGADORES"<<endl;
  
  
  setplayManager.updateInternalState(*tg);
  setplayManager.writeCurrentSetplay(cout);
  
 
  cout<<"_____________________________________________"<<endl;
 
  ball = new PointSimple(new Decimal(1),new Decimal(1));

  pl->clear();

  pl->push_back(new PointSimple(new Decimal(1),new Decimal(0)));
  pl->push_back(new PointSimple(new Decimal(2),new Decimal(0)));
  pl->push_back(new PointSimple(new Decimal(3),new Decimal(13)));
  pl->push_back(new PointSimple(new Decimal(4),new Decimal(2.6)));
  pl->push_back(new PointSimple(new Decimal(5),new Decimal(-6.1)));
  pl->push_back(new PointSimple(new Decimal(6),new Decimal(-17)));
  pl->push_back(new PointSimple(new Decimal(7),new Decimal(-1)));
  pl->push_back(new PointSimple(new Decimal(8),new Decimal(11)));
  pl->push_back(new PointSimple(new Decimal(9),new Decimal(-15)));
  pl->push_back(new PointSimple(new Decimal(10),new Decimal(-2)));
  pl->push_back(new PointSimple(new Decimal(11),new Decimal(19)));

  op->clear();
  op->push_back(new PointSimple(new Decimal(1),new Decimal(0)));
  op->push_back(new PointSimple(new Decimal(2),new Decimal(0)));
  op->push_back(new PointSimple(new Decimal(3),new Decimal(13)));
  op->push_back(new PointSimple(new Decimal(4),new Decimal(3)));
  op->push_back(new PointSimple(new Decimal(5),new Decimal(-6)));
  op->push_back(new PointSimple(new Decimal(6),new Decimal(-17)));
  op->push_back(new PointSimple(new Decimal(7),new Decimal(-1)));
  op->push_back(new PointSimple(new Decimal(8),new Decimal(11)));
  op->push_back(new PointSimple(new Decimal(9),new Decimal(-16)));
  op->push_back(new PointSimple(new Decimal(10),new Decimal(-3)));
  op->push_back(new PointSimple(new Decimal(11),new Decimal(19)));


  cout<<"_____________________________________________"<<endl;
  cout<<"2. SUBSTITUICAO DE POSICOES DA BOLA E JOGADORES"<<endl;

  setplayManager.updateInternalState(*tg);
  setplayManager.writeCurrentSetplay(cout);

  cout<<"_____________________________________________"<<endl;
  
  setplayManager.abort(*tg);
  cout<<"\nEsta' activo depois do abort?"<<setplayManager.isSetplayActive()<<endl;

 //  vector<const Participation*>* participations
  //     =substituteBallAndPlayersPositions(setplayManager.getSetplay(0)->initialParticipants(),
  // 				       ball,
  // 				       pl,
  // 				       op);
  
  
  //   cout<<"\n SUBSTITUIO DE POSIOES NAS PARTICIPACOES\n";
  //   for(unsigned int j=0;j!=participations->size();j++){
  //     participations->at(j)->print(cerr);
  //     cerr<<" ";
  //   }
  //   cerr<<endl;
  
  // Escolha dos jogadores
  vector<unsigned int>* vecStr=
    setplayManager.getSetplay(0)
    ->participatingPlayersDistanceFromPositions(*tg);
  cout<<"Jogadores escolhidos ";
  for(unsigned int i=0; i!= vecStr->size();i++)
    cout<<vecStr->at(i)<<" ";
  cout<<endl;
  //   setplayManager.writeCurrentSetplay(cout);
  //   cout<<"\nEsta' activo?"<<setplayManager.isSetplayActive()<<endl;
  
  // // (pt :x 0 :y 0) (pt :x 0 :y 0)
  // (pt :x 0 :y 0) (pt :x 0 :y 0)
  // (pt :x -17.3323 :y 13.0878) (pt :x 0 :y 13.0878)
  // (pt :x -16.6986 :y 2.625) (pt :x 0 :y 2.625)
  // (pt :x -17.3195 :y -6.18896) (pt :x 0 :y -6.18896)
  // (pt :x -17.5759 :y -17.6401) (pt :x 0 :y -17.6401)
  // (pt :x -8.71233 :y -0.875) (pt :x 0 :y -0.875)
  // (pt :x -2.57489 :y 10.8548) (pt :x 0 :y 10.8548)
  // (pt :x -2.74457 :y -15.9186) (pt :x 0 :y -15.9186)
  // (pt :x -1.33985 :y -2.49977) (pt :x 0 :y -2.49977)
  // (pt :x -1.49361 :y 19.7142) (pt :x 0 :y 19.7142)  
}
